package com.gyee.edge.loader.adapter;


import com.gyee.edge.loader.data.GeneralTsData;
import com.gyee.edge.loader.data.TsPointData;
import com.gyee.edge.loader.golden.ILatestDao;
import com.gyee.edge.loader.mapper.DBPointMapper;
import com.gyee.edge.loader.sqlite.cache.CacheService;
import com.gyee.protocol.gyfp2.message.GYMessage;
import com.gyee.protocol.gyfp2.message.MessageData;
import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.*;

/**
 * @author ：
 * @date ：Created in 2022/8/25 17:34
 * @description：  数据写入
 */

@Slf4j
@Component
public class DataWrite {
    @Autowired
    private ILatestDao iLatestDao;
    
    @Autowired
    private CacheService cacheService;


    public void DataWriteGloden(GYMessage gyMessage,String topic) throws Exception {
        List<TsPointData> tsDataList = new ArrayList<>();
        List<MessageData> messageDataList = gyMessage.getMessageDataList();
        try {
            if(gyMessage.getAttribute()==0){
                for(MessageData messageData:messageDataList){
                    TsPointData tsPointData = new TsPointData();
                    GeneralTsData generalTsData = new GeneralTsData();
                    String key = getPoint_key(messageData.getDataKey(),topic);
                    if(key != null && key.length()>0) {
                        tsPointData.setTagName(key);
                        generalTsData.setTs(messageData.getTs());
                        if (messageData.getDataType() == 0) {
                            generalTsData.setBooleanValue(messageData.getGYFP2_TYPE_BOOLEAN());
                        } else if (messageData.getDataType() == 10) {
                            generalTsData.setFloatValue(messageData.getGYFP2_TYPE_FLOAT32());
                        } else if (messageData.getDataType() == 8) {
                            generalTsData.setLongValue(messageData.getGYFP2_TYPE_INT64());
                        } else if (messageData.getDataType() == 11) {
                            generalTsData.setDoubleValue(messageData.getGYFP2_TYPE_FLOAT64());
                        }
                        generalTsData.setStatus((short) 1);
                        tsPointData.setTsData(generalTsData);
                        tsDataList.add(tsPointData);
                    }
                }
            }else if(gyMessage.getAttribute()==1){
                for(int i = 0; i < gyMessage.getMessageDataList().size();i++){
                    TsPointData tsPointData = new TsPointData();
                    GeneralTsData generalTsData = new GeneralTsData();
                    String key = getPoint_key(gyMessage.getMessageMutable().getKey() + i,topic);
                    if(key != null && key.length()>0) {
                        MessageData messageData = gyMessage.getMessageDataList().get(i);
                        tsPointData.setTagName(key);
                        generalTsData.setTs(messageData.getTs());
                        if (messageData.getDataType() == 0) {
                            generalTsData.setBooleanValue(messageData.getGYFP2_TYPE_BOOLEAN());
                        } else if (messageData.getDataType() == 10) {
                            generalTsData.setFloatValue(messageData.getGYFP2_TYPE_FLOAT32());
                        } else if (messageData.getDataType() == 8) {
                            generalTsData.setLongValue(messageData.getGYFP2_TYPE_INT64());
                        } else if (messageData.getDataType() == 11) {
                            generalTsData.setDoubleValue(messageData.getGYFP2_TYPE_FLOAT64());
                        }
                        generalTsData.setStatus((short) 1);
                        tsPointData.setTsData(generalTsData);
                        tsDataList.add(tsPointData);
                    }
                }
            }else if(gyMessage.getAttribute()==2){
                byte messageType = gyMessage.getMessageMutable().getMessageType();
                for(MessageData messageData:messageDataList){
                    TsPointData tsPointData = new TsPointData();
                    GeneralTsData generalTsData = new GeneralTsData();
                    String key = getPoint_key(messageData.getDataKey(),topic);
                    if(key != null && key.length()>0) {
                        tsPointData.setTagName(key);
                        generalTsData.setTs(messageData.getTs());
                        if (messageType == 0) {
                            generalTsData.setBooleanValue(messageData.getGYFP2_TYPE_BOOLEAN());
                        } else if (messageType == 10) {
                            generalTsData.setFloatValue(messageData.getGYFP2_TYPE_FLOAT32());
                        } else if (messageType == 8) {
                            generalTsData.setLongValue(messageData.getGYFP2_TYPE_INT64());
                        } else if (messageType == 11) {
                            generalTsData.setDoubleValue(messageData.getGYFP2_TYPE_FLOAT64());
                        }
                        generalTsData.setStatus((short) 1);
                        tsPointData.setTsData(generalTsData);
                        tsDataList.add(tsPointData);
                    }
                }
            }else if(gyMessage.getAttribute()==3){
                byte messageType = gyMessage.getMessageMutable().getMessageType();
                for(int i = 0; i < gyMessage.getMessageDataList().size();i++){
                    TsPointData tsPointData = new TsPointData();
                    GeneralTsData generalTsData = new GeneralTsData();
                    String key = getPoint_key(gyMessage.getMessageMutable().getKey()+ i,topic);
                    if(key != null && key.length()>0) {
                        MessageData messageData = gyMessage.getMessageDataList().get(i);
                        tsPointData.setTagName(key);
                        generalTsData.setTs(messageData.getTs());
                        if (messageType == 0) {
                            generalTsData.setBooleanValue(messageData.getGYFP2_TYPE_BOOLEAN());
                        } else if (messageType == 10) {
                            generalTsData.setFloatValue(messageData.getGYFP2_TYPE_FLOAT32());
                        } else if (messageType == 8) {
                            generalTsData.setLongValue(messageData.getGYFP2_TYPE_INT64());
                        } else if (messageType == 11) {
                            generalTsData.setDoubleValue(messageData.getGYFP2_TYPE_FLOAT64());
                        }
                        generalTsData.setStatus((short) 1);
                        tsPointData.setTsData(generalTsData);
                        tsDataList.add(tsPointData);
                    }
                }
            }else if(gyMessage.getAttribute()==4){
                long ts = gyMessage.getMessageMutable().getTs();
                for(MessageData messageData:messageDataList){
                    TsPointData tsPointData = new TsPointData();
                    GeneralTsData generalTsData = new GeneralTsData();
                    String key = getPoint_key(messageData.getDataKey(),topic);
                    if(key != null && key.length()>0) {
                        tsPointData.setTagName(key);
                        generalTsData.setTs(ts);
                        if (messageData.getDataType() == 0) {
                            generalTsData.setBooleanValue(messageData.getGYFP2_TYPE_BOOLEAN());
                        } else if (messageData.getDataType() == 10) {
                            generalTsData.setFloatValue(messageData.getGYFP2_TYPE_FLOAT32());
                        } else if (messageData.getDataType() == 8) {
                            generalTsData.setLongValue(messageData.getGYFP2_TYPE_INT64());
                        } else if (messageData.getDataType() == 11) {
                            generalTsData.setDoubleValue(messageData.getGYFP2_TYPE_FLOAT64());
                        }
                        generalTsData.setStatus((short) 1);
                        tsPointData.setTsData(generalTsData);
                        tsDataList.add(tsPointData);
                    }
                }
            }else if(gyMessage.getAttribute()==5){
                long ts = gyMessage.getMessageMutable().getTs();
                for(int i = 0; i < gyMessage.getMessageDataList().size();i++){
                    TsPointData tsPointData = new TsPointData();
                    GeneralTsData generalTsData = new GeneralTsData();
                    String key = getPoint_key(gyMessage.getMessageMutable().getKey() + i,topic);
                    if(key != null && key.length()>0) {
                        MessageData messageData = gyMessage.getMessageDataList().get(i);
                        tsPointData.setTagName(key);
                        generalTsData.setTs(ts);
                        if (messageData.getDataType() == 0) {
                            generalTsData.setBooleanValue(messageData.getGYFP2_TYPE_BOOLEAN());
                        } else if (messageData.getDataType() == 10) {
                            generalTsData.setFloatValue(messageData.getGYFP2_TYPE_FLOAT32());
                        } else if (messageData.getDataType() == 8) {
                            generalTsData.setLongValue(messageData.getGYFP2_TYPE_INT64());
                        } else if (messageData.getDataType() == 11) {
                            generalTsData.setDoubleValue(messageData.getGYFP2_TYPE_FLOAT64());
                        }
                        generalTsData.setStatus((short) 1);
                        tsPointData.setTsData(generalTsData);
                        tsDataList.add(tsPointData);
                    }
                }
            }else if(gyMessage.getAttribute()==6){
                long ts = gyMessage.getMessageMutable().getTs();
                byte messageType = gyMessage.getMessageMutable().getMessageType();
                for(MessageData messageData:messageDataList){
                    TsPointData tsPointData = new TsPointData();
                    GeneralTsData generalTsData = new GeneralTsData();
                    String key = getPoint_key(messageData.getDataKey(),topic);
                    if(key != null && key.length()>0) {
                        tsPointData.setTagName(key);
                        generalTsData.setTs(ts);
                        if (messageType == 0) {
                            generalTsData.setBooleanValue(messageData.getGYFP2_TYPE_BOOLEAN());
                        } else if (messageType == 10) {
                            generalTsData.setFloatValue(messageData.getGYFP2_TYPE_FLOAT32());
                        } else if (messageType == 8) {
                            generalTsData.setLongValue(messageData.getGYFP2_TYPE_INT64());
                        } else if (messageType == 11) {
                            generalTsData.setDoubleValue(messageData.getGYFP2_TYPE_FLOAT64());
                        }
                        generalTsData.setStatus((short) 1);
                        tsPointData.setTsData(generalTsData);
                        tsDataList.add(tsPointData);
                    }
                }
            }else if(gyMessage.getAttribute()==7){
                long ts = gyMessage.getMessageMutable().getTs();
                byte messageType = gyMessage.getMessageMutable().getMessageType();
                for(int i = 0;i < gyMessage.getMessageDataList().size();i++){
                    TsPointData tsPointData = new TsPointData();
                    GeneralTsData generalTsData = new GeneralTsData();
                    MessageData messageData = gyMessage.getMessageDataList().get(i);
                    String key = getPoint_key(gyMessage.getMessageMutable().getKey() + i,topic);
                    if(key != null && key.length()>0){
                        tsPointData.setTagName(key);
                        generalTsData.setTs(ts);
                        if(messageType == 0){
                            generalTsData.setBooleanValue(messageData.getGYFP2_TYPE_BOOLEAN());
                        }else if(messageType == 10){
                            generalTsData.setFloatValue(messageData.getGYFP2_TYPE_FLOAT32());
                        }else if(messageType == 8){
                            generalTsData.setLongValue(messageData.getGYFP2_TYPE_INT64());
                        }else if(messageType == 11){
                            generalTsData.setDoubleValue(messageData.getGYFP2_TYPE_FLOAT64());
                        }
                        generalTsData.setStatus((short) 1);
                        tsPointData.setTsData(generalTsData);
                        tsDataList.add(tsPointData);
                    }
                }
            }
            iLatestDao.writeLatest(tsDataList);
        }catch (Exception e){
            log.error("datawrite error",e);
        }
    }

    public String getPoint_key(int datakey,String topic) {
        Map<String, DBPointMapper> map = cacheService.getMap();
        if (map.isEmpty()) {
            return null;
        } else {
            for (Map.Entry<String, DBPointMapper> entry : map.entrySet()) {
                if (entry.getValue().getGyfp2_id().equals(topic) && entry.getValue().getGyfp2_address() == datakey) {
                    return entry.getKey();
                }
            }
            return null;
        }
    }

}
